/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mTF.lib.cfg;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.dukascopy.api.Instrument;
import com.dukascopy.api.OfferSide;
import java.io.Serializable;
/**
 *
 * @author Vladimir
 */
public class cfgOrder implements Serializable {
    private static final Logger LOGGER = LoggerFactory.getLogger(mTF.lib.cfg.cfgOrder.class);
    public Instrument instrument; //торговый инструмент
    public OfferSide offerSide; //Offer Side value
    public double lotSize; //размер лота
    public int slippage; //проскальзывание(пункты)
    public static boolean usingVCOS;// использовать виртуальное управление
    public boolean usingSL; //использовать защитный Стоп?
    public double slPercent; //порог защитного Стопа, в процентах
    public boolean usingBE; //использовать перенос в Безубыток?
    public double bePercent; //порог профита для переноса в Безубыток, в процентах
    public boolean usingTP; //использовать фиксацию Прибыли?
    public double tpPercent; //порог фиксации Прибыли, в процентах
    public boolean usingTS; //использовать трейлинг Стопа?
    public double tsPips; //дистанция между TS и Стопом, в пунктах
    
    //Constructor
    public cfgOrder() {
        instrument = Instrument.GBPUSD; //торговый инструмент
        offerSide = OfferSide.ASK; //Offer Side value
        lotSize = 0.001; //размер лота
        slippage = 10; //проскальзывание(пункты) Пробовал 15 - результат аналогичный
        usingVCOS = true;// использовать виртуальное управление
        usingSL = true; //использовать защитный Стоп?
        slPercent = 25.0; //порог защитного Стопа, в процентах
        usingBE = true; //использовать перенос в Безубыток?
        bePercent = 35.0; //порог профита для переноса в Безубыток, в процентах
        usingTP = true; //использовать фиксацию Прибыли?
        tpPercent = 70.0; //порог фиксации Прибыли, в процентах
        usingTS = true; //использовать фиксацию Прибыли?
        tsPips = 40.0; //дистанция между TS и Стопом, в пунктах
    }//End of Constructor

    public void logging() {
        LOGGER.info("tradeInstrument: "+instrument);
        LOGGER.info("tradeOfferSide: "+offerSide);
        LOGGER.info("lotSize: "+lotSize);
        LOGGER.info("slippage: "+slippage);
        LOGGER.info("usingVCOS: "+usingVCOS);
        LOGGER.info("usingSL: "+usingSL);
        LOGGER.info("slPercent: "+slPercent);
        LOGGER.info("usingBE: "+usingBE);
        LOGGER.info("bePercent: "+bePercent);
        LOGGER.info("usingTP: "+usingTP);
        LOGGER.info("tpPercent: "+tpPercent);
        LOGGER.info("usingTS: "+usingTS);
        LOGGER.info("tsPips: "+tsPips);
    }//End of logging
}//End of cfgOrder
