/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mTF.lib.cfg;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.dukascopy.api.Instrument;
import com.dukascopy.api.OfferSide;
import com.dukascopy.api.Filter;
import java.io.Serializable;

/**
 *
 * @author Vladimir
 */
public class cfgTrading implements Serializable {
    private static final Logger LOGGER = LoggerFactory.getLogger(mTF.lib.cfg.cfgTrading.class);
    public  Instrument instrument; //торговый инструмент
    public  int numberTF; //количество ТФ в спектре
    public  int startTF; //начальный ТФ в спектре (пункты/тики/возможно минуты)
    public  int stepTF; //шаг ТФ в спектре (пункты/тики/возможно минуты)
    public int signalSMATimePeriod; //период сигнальной SMA
    public Filter indicatorFilter; //фильтр SMA
    public int historyDataDepth; //глубина извлечения истории
    public OfferSide offerSide = OfferSide.ASK; //Offer Side value
    //==================Базовый торговый ордер====================
    public cfgOrder base_order;
//    public static boolean usingVCOS;// использовать виртуальное управление
    //================Хеджирующий торговый ордер==================
    public cfgOrder hedge_order;
    public boolean usingHedge; //использовать защитное Хеджирование противоордером?
    public double hedgeEnterPercent; //порог открытия Хеджирующей позиции, в процентах
    //*******************************************************************
    //public static boolean openChart; //Открывать графики ТФ?
    //public static boolean closeChart; //Закрывать графики ТФ после остановки?
    //public static boolean drawInd; //отображать индикаторы
    //public static boolean usingDebugInfo; //выводить отладочную информацию в журнал
    //*******************************************************************
    public String cfg_file_name;
    
    //Constructor
    public cfgTrading() {
        instrument = Instrument.GBPUSD; //торговый инструмент
        numberTF = 10; //количество ТФ в спектре
        startTF = 10; //начальный ТФ в спектре (пункты/тики/возможно минуты)
        stepTF = 10; //шаг ТФ в спектре (пункты/тики/возможно минуты)
        signalSMATimePeriod = 5; //период сигнальной SMA
        indicatorFilter = Filter.NO_FILTER; //фильтр SMA
        historyDataDepth = 2; //глубина извлечения истории
        offerSide = OfferSide.ASK; //Offer Side value;
        //==================Базовый торговый ордер====================
        base_order = new cfgOrder();
        base_order.instrument = instrument;
        base_order.offerSide = offerSide; //Offer Side value;
        base_order.lotSize = 0.001; //размер лота
        base_order.slippage = 10; //проскальзывание(пункты) Пробовал 15 - результат аналогичный
        base_order.usingSL = true; //использовать защитный Стоп?
        base_order.slPercent = 25.0; //порог защитного Стопа, в процентах
        base_order.usingTP = true; //использовать фиксацию Прибыли?
        base_order.tpPercent = 70.0; //порог фиксации Прибыли, в процентах
        base_order.usingBE = true; //использовать перенос в Безубыток?
        base_order.bePercent = 35.0; //порог профита для переноса в Безубыток, в процентах
        base_order.usingTS = true; //использовать тейлинг Стопа?
        base_order.tsPips = 40.0; //дистанция между TS и Стопом, в пунктах
        
        //usingVCOS = true;// использовать виртуальное управление
        
        //================Хеджирующий торговый ордер==================
        hedge_order = new cfgOrder();
        hedge_order.instrument = instrument;
        hedge_order.offerSide = offerSide; //Offer Side value
        hedge_order.lotSize = 0.001; //размер лота
        hedge_order.slippage = 10; //проскальзывание(пункты) Пробовал 15 - результат аналогичный
        hedge_order.usingSL = true; //использовать защитный Стоп?
        hedge_order.slPercent = 35.0; //порог защитного Стопа, в процентах
        hedge_order.usingTP = true; //использовать фиксацию Прибыли?
        hedge_order.tpPercent = 35.0; //порог фиксации Прибыли, в процентах 0 - закрытие по безубытку
        hedge_order.usingBE = true; //использовать перенос в Безубыток?
        hedge_order.bePercent = 35.0; //порог профита для переноса в Безубыток, в процентах
        hedge_order.usingTS = true; //использовать трейлинг Стопа?
        hedge_order.tsPips = 40.0; //дистанция между TS и Стопом, в пунктах
        usingHedge = true; //использовать защитное Хеджирование противоордером?
        hedgeEnterPercent = 25.0; //порог открытия Хеджирующей позиции, в процентах
        
    //*******************************************************************
    //openChart; //Открывать графики ТФ?
    //closeChart; //Закрывать графики ТФ после остановки?
    //drawInd; //отображать индикаторы
    //usingDebugInfo; //выводить отладочную информацию в журнал
    //*******************************************************************
        cfg_file_name = "";
    }//End of Constructor
    
    public void logging() {
        LOGGER.info("//====================================");
        LOGGER.info("instrument: "+instrument);
        LOGGER.info("numberTF: "+numberTF);
        LOGGER.info("startTF: "+startTF);
        LOGGER.info("stepTF: "+stepTF);
        LOGGER.info("signalSMATimePeriod: "+signalSMATimePeriod);
        LOGGER.info("indicatorFilter: "+indicatorFilter);
        LOGGER.info("historyDataDepth: "+historyDataDepth);
        LOGGER.info("offerSide: "+offerSide);
        LOGGER.info("//==== Базовый торговый ордер ====");
        base_order.logging();
        LOGGER.info("//==== Хеджирующий торговый ордер ====");
        LOGGER.info("usingHedge: "+usingHedge);
        LOGGER.info("hedgeEnterPercent: "+hedgeEnterPercent);
        hedge_order.logging();
        LOGGER.info("//====================================");
    }//End of logging
}//End of cfgTrading
