/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mTF.lib.cfg;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 *
 * @author Vladimir
 */
public class connectionSettings implements Serializable {
    private static final Logger LOGGER = LoggerFactory.getLogger(mTF.lib.cfg.connectionSettings.class);
    public cfgConnection settings;

    //Constructor
    public connectionSettings(String cfg_file) {
        settings = new cfgConnection(cfg_file);
        if(Load(cfg_file)){
            LOGGER.info("[connection settings file]: - Loading OK!");
        } else {
            LOGGER.info("[connection settings file]: - Loading ERROR!");
            settings = new cfgConnection(cfg_file);
            LOGGER.info("[connection settings file]: - setup defaults settings");
        }
    }//End of Conctructor
    
    public final boolean Load(String cfg_file) {
        File con_file = new File(cfg_file);
        if (con_file.exists() && con_file.isFile()) {
            ObjectInputStream con_ois = null;
            try {
                con_ois = new ObjectInputStream(new FileInputStream(cfg_file));
                settings = (cfgConnection) con_ois.readObject();
                con_ois.close();
                return true;
            } catch (FileNotFoundException ex) {
                LOGGER.info("[connection settings file]: - from FileNotFoundException catch: " + ex);
                return false;
            } catch (IOException ex) {
                LOGGER.info("[connection settings file]: - from IOException catch: " + ex);
                return false;
            } catch (ClassNotFoundException ex) {
                LOGGER.info("[connection settings file]: - from ClassNotFoundException catch: " + ex);
                return false;
            } finally {
                if (con_ois != null) {
                    try {
                        con_ois.close();
                    } catch (IOException ex) {
                        LOGGER.info("[ObjectInputStream]: - from IOException catch: " + ex);
                    }
                }
            }           
        } else {
            return false;
        }
    }//End of Load
    
    public final boolean Save(String cfg_file) {
        ObjectOutputStream oos = null;
        try {
            oos = new ObjectOutputStream(new FileOutputStream(cfg_file));
            oos.writeObject(settings);
            oos.flush();
            return true;
        } catch (FileNotFoundException ex) {
            LOGGER.info("[connection settings file]: - from FileNotFoundException catch: " + ex);
            return false;
        } catch (IOException ex) {
            LOGGER.info("[connection settings file]: - from IOException catch: " + ex);
            return false;
        } finally {
            if (oos != null) {
                try {
                    oos.close();
                } catch (IOException ex) {
                    LOGGER.info("[ObjectInputStream]: - from IOException catch: " + ex);
                }
            }
        }
    }//End of Save
}//End of connectionSettings
