/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mTF.tester;

import java.awt.*;
//import java.awt.event.*;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.Future;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.SwingUtilities;
import javax.swing.BorderFactory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.dukascopy.api.IChart;
import com.dukascopy.api.Instrument;
import com.dukascopy.api.LoadingProgressListener;
import com.dukascopy.api.system.ISystemListener;
//import com.dukascopy.api.system.IClient;
//import com.dukascopy.api.system.ClientFactory;
import com.dukascopy.api.system.ITesterClient;
import com.dukascopy.api.system.ITesterClient.DataLoadingMethod;
import com.dukascopy.api.system.TesterFactory;
import com.dukascopy.api.system.tester.ITesterExecution;
import com.dukascopy.api.system.tester.ITesterExecutionControl;
import com.dukascopy.api.system.tester.ITesterGui;
import com.dukascopy.api.system.tester.ITesterUserInterface;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

import mTF.lib.cfg.*;
import mTF.lib.dlg.*;
import mTF.lib.strategy.*;
/**
 *
 * @author Vladimir
 */

@SuppressWarnings("serial")
public class mTF_tester extends JFrame implements ITesterUserInterface, ITesterExecution, ActionListener {
    private static connectionSettings connection_cfg = null;
    private static tradingSettings trading_cfg = null;
    
    private ITesterClient client = null;
    //private final static strategy_play strategy = null;
    //private final long strategyId = 0;

    //Menu Actions
    private enum Actions {
        CONNECTION_SETTINGS,
        LOAD_TRADING_SETTINGS,
        TRADING_SETTINGS
    }//End of Menu Actions
    
    //--------------------------
    MenuItem f1, f2, f3, f5;
    //--------------------------
    private final int controlPanelHeight = 40;
    private JPanel currentChartPanel = null;
    private ITesterExecutionControl executionControl = null;
    private JPanel controlPanel = null;
    private JButton startStrategyButton = null;
    private JButton cancelStrategyButton = null;
    private JButton pauseStrategyButton = null;
    private JButton continueStrategyButton = null;
    //-----------------------------------
    private static final Logger LOGGER = LoggerFactory.getLogger(mTF.tester.mTF_tester.class);

    //Constructor
    public mTF_tester(){
    	//setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
    }//End of Constructor
    
    public static void main(String[] args) throws Exception {
        connection_cfg = new connectionSettings("mtf_connection.cfg");
        //connection_cfg.settings.logging();
        trading_cfg = new tradingSettings(args[0]);
        //trading_cfg.settings.logging();
        LOGGER.info("Running program ... ");
    	mTF_tester main_window = new mTF_tester();
    	main_window.showFrame();
        //strategy = new strategy_play();
    }//End of main

    public void showFrame(){
        setTitle("mTF - StrategyTester - ");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(0, 0);  
        setSize(new Dimension(dim.width, dim.height));
        makeMenu();
	addControlPanel();
        setVisible(true);
    }//End of showFrame

    private void makeMenu() {
        MenuBar menu = new MenuBar();
        setMenuBar(menu);
        //---------------
        Menu m_file = new Menu("File");
        Menu m_trade = new Menu("Trade");
        //-------------------
        f1 = new MenuItem("Connection Settings...");
        f1.setActionCommand(Actions.CONNECTION_SETTINGS.name());
        f1.addActionListener(this);
        m_file.add(f1);
        m_file.add( new MenuItem("-"));
        f2 = new MenuItem("Exit");
        f2.addActionListener(this);
        m_file.add(f2);
        //-------------
        f3 = new MenuItem("Load Settings...");
        f3.setActionCommand(Actions.LOAD_TRADING_SETTINGS.name());
        f3.addActionListener(this);
        m_trade.add(f3);
        m_trade.add( new MenuItem("-"));
        f5 = new MenuItem("Trading Settings...");
        f5.setActionCommand(Actions.TRADING_SETTINGS.name());
        f5.addActionListener(this);
        m_trade.add(f5);
        //-------------
        menu.add(m_file);
        menu.add(m_trade);
    }//End of makeMenu
     
    //Events
    @Override
    public void actionPerformed(ActionEvent e) {
        String actionStr = (String) e.getActionCommand();
        if(actionStr.equals(Actions.CONNECTION_SETTINGS.name())) {
            dlgConnectionSettings settingsConnectionDialog = new dlgConnectionSettings(mTF.tester.mTF_tester.this, connection_cfg);
            settingsConnectionDialog.setVisible(true);
        } else if(actionStr.equals(Actions.TRADING_SETTINGS.name())) {
            dlgTradingSettings settingsTradingDialog = new dlgTradingSettings(mTF.tester.mTF_tester.this, trading_cfg);
            settingsTradingDialog.setVisible(true);
        } else if(actionStr.equals(Actions.LOAD_TRADING_SETTINGS.name())) {
            final JFileChooser fc = new JFileChooser();
            fc.setDialogTitle("Load trading settings...");
            fc.setCurrentDirectory(new File("."));
            FileNameExtensionFilter filter=new FileNameExtensionFilter("Trading configuration file (*.dat)", "dat", "dat");
            fc.setFileFilter(filter);
            int returnVal = fc.showOpenDialog(mTF.tester.mTF_tester.this);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                String file = fc.getSelectedFile().getName();
                trading_cfg.Load(file);
            }
        } else if(actionStr.equals("Exit")) {
            // Check exit rules
            
            // End program
            dispose();
            System.exit(0);
        }
    }//End of actionPerformed
    
    @Override
    public void setChartPanels(Map<IChart, ITesterGui> chartPanels) {
        for(Map.Entry<IChart, ITesterGui> entry : chartPanels.entrySet()){
            IChart chart = entry.getKey();
            JPanel chartPanel = entry.getValue().getChartPanel();
            if(chart.getFeedDescriptor().getInstrument().equals(trading_cfg.settings.instrument)){
                setTitle(chart.getFeedDescriptor().toString());   
                addChartPanel(chartPanel);
                break;
            }
        }
    }//End of setChartPanels
    
 //       @Override
 //   	// 1) change the setChartPanels method
//	public void setChartPanels(Map<IChart, ITesterGui> chartPanels) {
//		if (chartPanels != null && chartPanels.size() > 0) {
//			for (IChart chart : chartPanels.keySet()) {
//				LOGGER.debug("Chart for instrument"	+ chart.getInstrument().toString());
//
//				Instrument instrument = chart.getInstrument();
//				setTitle(instrument.toString() + " "+ chart.getSelectedOfferSide() + " "+ chart.getSelectedPeriod());
//
//				// show ticks for EURUSD and 10 min bars for other instruments
//				if (chart.getInstrument().equals(Instrument.EURUSD)) {
//			        IFeedDescriptor feedDescriptor = new FeedDescriptor();
//			        feedDescriptor.setDataType(DataType.TICKS);
//			        feedDescriptor.setInstrument(Instrument.EURUSD);			        
//					chartPanels.get(chart).getTesterChartController().setFeedDescriptor(feedDescriptor);
//				} else {
//			        IFeedDescriptor feedDescriptor = new FeedDescriptor();
//			        feedDescriptor.setDataType(DataType.TIME_PERIOD_AGGREGATION);
//			        feedDescriptor.setOfferSide(OfferSide.BID);
//			        feedDescriptor.setInstrument(Instrument.EURUSD);		
//			        feedDescriptor.setPeriod(Period.TEN_MINS);
//					chartPanels.get(chart).getTesterChartController().setFeedDescriptor(feedDescriptor);
//				}
//
//				JPanel chartPanel = chartPanels.get(chart).getChartPanel();
//				addChartPanel(chartPanel);
//			}
//		}
//	}
        

    /**
     * Add chart panel to the frame
     */
    private void addChartPanel(JPanel chartPanel) {
	removecurrentChartPanel();
		
	this.currentChartPanel = chartPanel;
	chartPanel.setPreferredSize(new Dimension(this.getWidth(), this.getHeight() - controlPanelHeight));
	chartPanel.setMinimumSize(new Dimension(this.getWidth(), 200));
	chartPanel.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
	getContentPane().add(chartPanel);
	this.validate();
	chartPanel.repaint();
    }//End of addChartPanel
        
    private void removecurrentChartPanel(){
	if(this.currentChartPanel != null){
            try {
            	SwingUtilities.invokeAndWait(new Runnable() {
                    @Override
                    	public void run() {
                            mTF.tester.mTF_tester.this.getContentPane().remove(mTF.tester.mTF_tester.this.currentChartPanel);
                            mTF.tester.mTF_tester.this.getContentPane().repaint();
			}
		});				
            } catch (Exception e) {
                LOGGER.error(e.getMessage(), e);
            }
	}
    }//End of removecurrentChartPanel

    @Override
    public void setExecutionControl(ITesterExecutionControl executionControl) {
		this.executionControl = executionControl;
    }//End of setExecutionControl

    private void addControlPanel() {
	controlPanel = new JPanel();
	FlowLayout flowLayout = new FlowLayout(FlowLayout.CENTER);
	controlPanel.setLayout(flowLayout);
	controlPanel.setPreferredSize(new Dimension(getWidth(), controlPanelHeight));
	controlPanel.setMinimumSize(new Dimension(getWidth(), controlPanelHeight));
	controlPanel.setMaximumSize(new Dimension(Short.MAX_VALUE, controlPanelHeight));
        controlPanel.setBorder(BorderFactory.createEtchedBorder(1));

	startStrategyButton = new JButton("Start");
        startStrategyButton.setEnabled(true);
	startStrategyButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                startStrategyButton.setEnabled(false);
		Runnable r = new Runnable() {
                    public void run() {
			try {
                            startStrategy();
			} catch (Exception e2) {
                            LOGGER.error(e2.getMessage(), e2);
                            e2.printStackTrace();
                            resetButtons();
			}
                    }
		};
		Thread t = new Thread(r);
		t.start();
            }
	});
		
	pauseStrategyButton = new JButton("Pause");
        pauseStrategyButton.setEnabled(false);
	pauseStrategyButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(executionControl != null){
                    executionControl.pauseExecution();
                    updateButtons();
		}
            }
	});
		
	continueStrategyButton = new JButton("Continue");
        continueStrategyButton.setEnabled(false);
	continueStrategyButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(executionControl != null){
                    executionControl.continueExecution();
                    updateButtons();
		}
            }
	});
		
	cancelStrategyButton = new JButton("Cancel");
        cancelStrategyButton.setEnabled(false);
	cancelStrategyButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
		if(executionControl != null){
                    executionControl.cancelExecution();
                    updateButtons();
		}
            }
	});

		
	controlPanel.add(startStrategyButton);
	controlPanel.add(pauseStrategyButton);
	controlPanel.add(continueStrategyButton);
	controlPanel.add(cancelStrategyButton);
	getContentPane().add(controlPanel);
    }//End of addControlPanel

    private void updateButtons(){
	if(executionControl != null){
            startStrategyButton.setEnabled(executionControl.isExecutionCanceled());
            pauseStrategyButton.setEnabled(!executionControl.isExecutionPaused() && !executionControl.isExecutionCanceled());
            cancelStrategyButton.setEnabled(!executionControl.isExecutionCanceled());
            continueStrategyButton.setEnabled(executionControl.isExecutionPaused());
	}
    }//End of updateButtons

    private void resetButtons(){
        startStrategyButton.setEnabled(true);
        pauseStrategyButton.setEnabled(false);
        continueStrategyButton.setEnabled(false);
        cancelStrategyButton.setEnabled(false);
    }//End of resetButtons
    
    public void startStrategy() throws Exception {
        //get the instance of the IClient interface
        client = TesterFactory.getDefaultInstance();
        //set the listener that will receive system events
        client.setSystemListener(new ISystemListener() {
            private int lightReconnects = connection_cfg.settings.reconnects;
            @Override
            public void onStart(long processId) {
                LOGGER.info("Strategy started: " + processId);
                updateButtons();
            }

            @Override
            public void onStop(long processId) {
                LOGGER.info("Strategy stopped: " + processId);
                resetButtons();
       
                File reportFile = new File(trading_cfg.settings.instrument.getPrimaryJFCurrency().toString()
                        +trading_cfg.settings.instrument.getSecondaryJFCurrency().toString()+"-report"+processId+".html");
                try {
                    client.createReport(processId, reportFile);
                } catch (Exception e) {
                    LOGGER.error(e.getMessage(), e);
                }
            }

            @Override
            public void onConnect() {
                LOGGER.info("Connected");
                lightReconnects = connection_cfg.settings.reconnects;
            }

            @Override
            public void onDisconnect() {
                LOGGER.warn("Disconnected");
                if (lightReconnects > 0) {
                    LOGGER.error("TRY TO RECONNECT, reconnects left: " + lightReconnects);
                    client.reconnect();
                    --lightReconnects;
                } else {
                    try {
                        //sleep for 10 seconds before attempting to reconnect
                        Thread.sleep(10000);
                    } catch (InterruptedException e) {
                        //ignore
                    }
                    try {
                        client.connect(connection_cfg.settings.url, connection_cfg.settings.username, connection_cfg.settings.password);
                    } catch (Exception e) {
                        LOGGER.error(e.getMessage(), e);
                    }
                }
            }
        });

        LOGGER.info("Connecting...");
        //connect to the server using jnlp, user name and password
        //connection is needed for data downloading
        client.connect(connection_cfg.settings.url, connection_cfg.settings.username, connection_cfg.settings.password);

        //wait for it to connect
        int i = 10; //wait max ten seconds
        while (i > 0 && !client.isConnected()) {
            Thread.sleep(1000);
            i--;
        }
        if (!client.isConnected()) {
            LOGGER.error("Failed to connect Dukascopy servers");
            System.exit(1);
        }

        
        //set instruments that will be used in testing
        final Set<Instrument> instruments = new HashSet<>();
        instruments.add(trading_cfg.settings.instrument);
        
        LOGGER.info("Subscribing instruments...");
        client.setSubscribedInstruments(instruments);
        //setting initial deposit
        client.setInitialDeposit(Instrument.EURUSD.getSecondaryJFCurrency(), 1000);
        //client.setCacheDirectory(null);
        //client.setLeverage(100);
        final SimpleDateFormat dateFormat = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
        dateFormat.setTimeZone(TimeZone.getTimeZone("GMT"));

        Date dateFrom = dateFormat.parse("01/01/2015 12:00:00");
        Date dateTo = dateFormat.parse("09/22/2015 00:00:00");

        client.setDataInterval(DataLoadingMethod.ALL_TICKS, dateFrom.getTime(), dateTo.getTime());
        LOGGER.info("from: " + dateFrom.toString() + " to: " + dateTo.toString());
        
        //load data
        LOGGER.info("Downloading data");
        Future<?> future = client.downloadData(null);
        //wait for downloading to complete
        future.get();
        //start the strategy
        LOGGER.info("Starting strategy");
//================================================
//        //set instruments that will be used in testing
//        final Set<Instrument> instruments = new HashSet<>();
//        instruments.add(trading_cfg.settings.instrument);
        
//        LOGGER.info("Subscribing instruments...");
//        client.setSubscribedInstruments(instruments);
//        //setting initial deposit
//        client.setInitialDeposit(Instrument.EURUSD.getSecondaryJFCurrency(), 1000);
//        //load data
//        LOGGER.info("Downloading data");
//        Future<?> future = client.downloadData(null);
//        //wait for downloading to complete
//        future.get();
//        //start the strategy
//        LOGGER.info("Starting strategy");
        
        
        
        client.startStrategy(
    		new strategy_play(trading_cfg.settings),
    		new LoadingProgressListener() {
    			@Override
    			public void dataLoaded(long startTime, long endTime, long currentTime, String information) {
    				LOGGER.info(information);
    			}

    			@Override
    			public void loadingFinished(boolean allDataLoaded, long startTime, long endTime, long currentTime) {
    			}

    			@Override
    			public boolean stopJob() {
    				return false;
    			}
    		}, this, this
        );
        //now it's running
    }//End of startStrategy
}//End of mTF_tester
